package com.tanpu.community.feign.tanpuroom;

import com.tanpu.common.api.CommonResp;
import com.tanpu.community.feign.tanpuroom.vo.CurriCulumInfoDetailDto;
import com.tanpu.community.feign.tanpuroom.vo.CurriculumDetailVo;
import com.tanpu.community.feign.vo.ShortVideoBaseInfoResp;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;

@Slf4j
@Component
public class FeignBackClientForTanpuroom implements FallbackFactory<FeignClientForTanpuroom> {

    @Override
    public FeignClientForTanpuroom create(Throwable throwable) {
        return new FeignClientForTanpuroom() {
            @Override
            public CommonResp<List<ShortVideoBaseInfoResp>> getShortVideoBaseInfo(List<String> sourceIds) {
                log.error("请求信息", throwable);
                log.error("FeignBackClientForTanpuroom.getShortVideoBaseInfo-查询短视频ids:{}", sourceIds);
                return null;
            }

            @Override
            public CommonResp<CurriculumDetailVo> queryCurriculumDetail(CurriCulumInfoDetailDto req) {
                log.error("请求信息", throwable);
                log.error("FeignBackClientForTanpuroom.getShortVideoBaseInfo-查询课程req:{}", req);
                return null;
            }
        };
    }
}
